/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef EDISASSM_EXCEPTION_20080414_H_
#define EDISASSM_EXCEPTION_20080414_H_

struct invalid_instruction : public std::exception {
public:
	invalid_instruction(std::size_t size) : m_Size(size) { }
	std::size_t size() const { return m_Size; }
private:
	std::size_t m_Size;
};

struct instruction_too_big		: public invalid_instruction { instruction_too_big(std::size_t size)	: invalid_instruction(size) {} };
struct invalid_operand			: public invalid_instruction { invalid_operand(std::size_t size)		: invalid_instruction(size) {} };
struct too_many_operands		: public invalid_instruction { too_many_operands(std::size_t size)		: invalid_instruction(size) {} };
struct multiple_displacements	: public invalid_instruction { multiple_displacements(std::size_t size)	: invalid_instruction(size) {} };

#endif
