/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef DIALOGENVIRONMENT_20070705_H_
#define DIALOGENVIRONMENT_20070705_H_

#include "ui_dialogenvironment.h"
#include "Types.h"
#include <QString>

class QStringListModel;
class QSortFilterProxyModel;

class DialogEnvironment : public QDialog {
	Q_OBJECT
	
public:
	DialogEnvironment(QWidget *parent = 0);

public Q_SLOTS:
	void on_listView_doubleClicked(const QModelIndex &index);
	void on_btnRefresh_clicked();
	
private:
	virtual void showEvent(QShowEvent *event);

private:
	QString getLibcName() const;
	void doFind();

private:
	 Ui::DialogEnvironment	ui;
	 QStringListModel		*m_Model;
	 QSortFilterProxyModel	*m_FilterModel;
};

#endif
