/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "HeapAnalyzer.h"
#include "DialogHeap.h"
#include "Debugger.h"
#include <QMenu>

//------------------------------------------------------------------------------
// Name: HeapAnalyzer()
// Desc: 
//------------------------------------------------------------------------------
HeapAnalyzer::HeapAnalyzer() : m_Menu(0), m_Dialog(0) {
}

//------------------------------------------------------------------------------
// Name: ~HeapAnalyzer()
// Desc: 
//------------------------------------------------------------------------------
HeapAnalyzer::~HeapAnalyzer() {
	delete m_Dialog;
}

//------------------------------------------------------------------------------
// Name: menu(QWidget *parent)
// Desc: 
//------------------------------------------------------------------------------
QMenu *HeapAnalyzer::menu(QWidget *parent) {

	if(m_Menu == 0) {
		m_Menu = new QMenu(tr("HeapAnalyzer"), parent);
		m_Menu->addAction (tr("&Heap Analyzer"), this, SLOT(doMenu()), QKeySequence(tr("Ctrl+H")));
	}
	
	return m_Menu;
}

//------------------------------------------------------------------------------
// Name: mnuHeapAnalyzer()
// Desc: 
//------------------------------------------------------------------------------
void HeapAnalyzer::doMenu() {

	if(m_Dialog == 0) {
		m_Dialog = new DialogHeap(edb::v1::debuggerUI);
	}
	
	m_Dialog->show();
}

Q_EXPORT_PLUGIN2(HeapAnalyzer, HeapAnalyzer)
