/*
Copyright (C) 2006 - 2009 Evan Teran
                   eteran@alum.rit.edu

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "SessionManager.h"
#include "Debugger.h"
#include <QtDebug>

//------------------------------------------------------------------------------
// Name: privateInit()
// Desc: 
//------------------------------------------------------------------------------
void SessionManager::privateInit() {
	edb::v1::setSessionFileHandler(this);
}

//------------------------------------------------------------------------------
// Name: saveSessionData(const QString &filename, const QString &executable)
// Desc: 
//------------------------------------------------------------------------------
void SessionManager::saveSessionData(const QString &filename, const QString &executable) {
	qDebug() << "[SessionManager] saving session file:" << filename <<  "for:" << executable;
}

//------------------------------------------------------------------------------
// Name: loadSessionData(const QString &filename)
// Desc: 
//------------------------------------------------------------------------------
void SessionManager::loadSessionData(const QString &filename, const QString &executable) {
	qDebug() << "[SessionManager] loading session file:" << filename <<  "for:" << executable;
}


//------------------------------------------------------------------------------
// Name: menu(QWidget *parent)
// Desc: 
//------------------------------------------------------------------------------
QMenu *SessionManager::menu(QWidget *parent) {
	Q_UNUSED(parent);
	return 0;
}

Q_EXPORT_PLUGIN2(SessionManager, SessionManager)
